
!macro stxy .target {
	stx	.target
	sty	.target+1
}

!macro ldxy .target {
	ldx	.target
	ldy	.target+1
}

!macro addxy .target {
	clc
	txa
	adc	.target
	tax
	tya
	adc	.target+1
	tay
}

!macro add16 .target {
	clc
	adc	.target
	sta	.target
	lda	#0
	adc	.target+1
	sta	.target+1
}


!macro addxyto .target {
	clc
	txa
	adc	.target
	sta	.target
	tya
	adc	.target+1
	sta	.target+1
}

!macro lsl16 .target,.steps {
	lda	.target
	ldx	#steps
.loop
	asl
	rol	.target+1
	dex
	bne	.loop
	sta	.target
}

!macro lsl16 .target {
	asl	.target
	rol	.target+1
}

!macro lsr16 .target {
	lsr	.target+1
	ror	.target
}

!macro inc32 .target {
	inc	.target
	bne	.skip
	inc	.target+1
	bne	.skip
	inc	.target+2
	bne	.skip
	inc	.target+3
.skip
}

break_adr = $fb

!macro break {
	pha
	lda	#$09
	sta	$df11
	lda	break_adr
.wait
	cmp	break_adr
	beq	.wait
	lda	#$08
	sta	$df11
	pla
}

!macro error .color {
.loop
	lda	#.color
	sta	$d020
	lda	#0
	sta	$d020
	jmp	.loop
}

!macro varstart .adr {
	!set external_pc = .adr
}

!macro adrxy .adress {
	ldx	#((.adress) & 0xff)
	ldy	#((.adress) >> 8)
}

!macro var16 ~.adr {
	.adr = external_pc
	!set external_pc = external_pc + 2
}

!macro var8 ~.adr {
	.adr = external_pc
	!set external_pc = external_pc + 1
}

!macro var0 ~.adr {
	.adr = external_pc
}


!macro reserve ~.adr,.size {
	.adr = external_pc
	!set external_pc = external_pc + .size
}

